#ifndef DATACOMMON_H
#define DATACOMMON_H

#include <QObject>
#include <QThread>
#include "CommonInfoModule.h"
#include "DBusModule.h"
#include "CacheModule.h"
#include "TransmitModule.h"
#include "BasicInfoModule.h"
#include "ConfModule.h"
#include "OnlineInfoModule.h"


class DataCommon:public QObject
{
    Q_OBJECT
public:
    DataCommon(QObject *parent=nullptr);
    ~DataCommon();
private:
    void createObject();
    void connectObject();
    void startObject();
private:
    BasicInfoModule *basicInfoModule;
    OnlineInfoModule *onlineInfoModule;
    CommonInfoModule *commonInfoModule;
    DBusModule *dataCollection;
    CacheModule *cacheModule;
    TransmitModule *transmitModule;
    ConfModule *confModule;

    QThread *basicInfoModuleThread;
    QThread *commonInfoModuleThread;
    QThread *onlineInfoModuleThread;
    QThread *dataCollectionThread;
    QThread *cacheModuleThread;
    QThread *transmitModuleThread;
    QThread *confModuleThread;
signals:
    void controlCollectInfo();
};
#endif
