#ifndef ONLINEINFOCOLLECTION_H
#define ONLINEINFOCOLLECTION_H

#include <QObject>
#include "./KylinDaqCommon.h"
#include "./InfoCollectionBase.h"
#include <QDateTime>


typedef struct
{
    QString bootDateTime;
    QString shutdownDateTime;
    QString lastRunDateTimeInterval;
    QString lastShutdownDateTimeInterval;
    qlonglong lastRunDateTimeQuantum;
    qlonglong lastShutdownDateTimeQuantum;

} OnlineInfo;

class OnlineInfoCollection : public InfoCollectionBase
{
    Q_OBJECT
private:
    QString bootDateTimeCmd;
    QString shutdownDateTimeCmd;
    QString penultimateBootDateTimeCmd;
public:
    explicit OnlineInfoCollection(QObject *parent = nullptr);

    void getInfo(OnlineInfo &onlineInfo);
signals:

};

#endif // ONLINEINFOCOLLECTION_H
